﻿<script>

    var chkGrider = new checkBoxGrid('#grdCadastroConsultor');

    //Tratamento de validação
    var tooltipValidationNovo = function () {

        var mostrarToolTip = 0;

        if ($('#selFnc').val() == null) {
            tooltipCampoObrigatorio(".select2fnc", "Selecione um Funcionário");
            mostrarToolTip = mostrarToolTip + 1;
        }

        if ($('#ddlCodPflAcs').val() == 0) {
            tooltipCampoObrigatorio("#ddlCodPflAcs", "Selecione um Perfil");
            mostrarToolTip = mostrarToolTip + 1;
        }

        if (mostrarToolTip > 0) {
            return false;
        }
    }

    //Tratamento de validação
    var tooltipValidationEditar = function () {

        var mostrarToolTip = 0;

        if ($('#ddlCodPflAcs').val() == 0) {
            tooltipCampoObrigatorio("#ddlCodPflAcs", "Selecione um Perfil");
            mostrarToolTip = mostrarToolTip + 1;
        }

        if (mostrarToolTip > 0) {
            return false;
        }
    }

    //Limpa os campos e recarrega o grid ao fechar o cadastro.
    $('#btnFecharCadastro').click(function () {
        limparTodosOsCampos("divCadastro");
        $('#divCadastro').hide();
        $('#divPesquisa').show();
        apagaTooltipCampos();

        closeLog();

        if ($("#grdCadastroConsultorContainer > tbody > tr > td").text().toString().trim() != 'Nenhum registro encontrado') {
            $("#grdCadastroConsultor").DataTable().ajax.reload();
        }
    });

    //Funções para mostrar botão editar e novo.
    var editar = function () {
        $("#btnInserirCadastro").hide();
        $("#btnEditarCadastro").show();

        $(".divShowHide").fadeIn();
        $('#divFunInserir').hide();
        $('#divFunEditar').show();
    }

    var novo = function () {

        $('#selCon').text(null).trigger('change');
        $('#ddlStatus').val(0);

        $("#btnInserirCadastro").show();
        $("#btnEditarCadastro").hide();

        $(".divShowHide").hide();
        $('#divFunInserir').show();
        $('#divFunEditar').hide();
    }

    //-Log Info
    $('#btnLogInfo').click(function () {
        var ctn = $('#logInfoContainer');
        if (ctn.attr('class').indexOf('is-open') < 0) {
            ctn.addClass('is-open');
            $(this).attr('class', 'fa fa-times');
            //-timeout.
            var openKey = 'info-cnt' + (Math.random() * 500).toFixed(0);
            ctn.attr('data-open-key', openKey);
            @*Função que fecha o log ao clicar fora ou nele*@
            $('body').append($('<div class="drop-background">').click(function () {
                ctn.removeClass('is-open');
                $('#btnLogInfo').attr('class', 'fa fa-file-text-o');
                this.remove();
            }));
        } else {
            ctn.removeClass('is-open');
            $(this).attr('class', 'fa fa-file-text-o');
        }
    });

    var closeLog = function (last) {
        $('#logInfoContainer').removeClass('is-open');
        $('#btnLogInfo').attr('class', 'fa fa-file-text-o');
    };
        //----------

    //Evento que chama a pesquisa da tela.
    $("#btnPesquisarTela").click(function () {
        $("#grdCadastroConsultor").DataTable().ajax.reload();
    });

    //Função que carrega a funcionalidade da abertura do cadastro ao clicar na linha, ele carrega todas as informações no cadastro.
    var csnCallBack = function () {
        chkGrider.reworkConsulta();
        $('#grdCadastroConsultor tbody tr td').each(function () {

            var data = ($('#grdCadastroConsultor').DataTable()).data();

            if (data.length > 0) {

                $(this).click(function () {
                    var dados = data.row($(this).parent()).data();

                    //$('#txtFnc').val(dados.CODFNC);

                    //if (dados.CODFNC !== (-1) && dados.CODFNC !== null && dados.NOMFNC !== null) {
                    //    $('#selFnc').html('<option value="' + dados.CODFNC + '">' +
                    //        dados.NOMFNC + '</option>').trigger('change');
                    //};

                    $('#txtCodFnc').val(dados.CODFNC);
                    $('#txtNomFnc').val(dados.NOMFNC);



                    $('#ddlCodPflAcs').val(dados.CODPFLACS);

                    $('#txtFncCadLog').val(dados.FNCCAD);
                    $('#txtDatFncCadLog').val(dados.DATFNCCAD);
                    $('#txtFncAltLog').val(dados.FNCALT);
                    $('#txtDatFncAltLog').val(dados.DATFNCALT);
                    $('#txtFncDstLog').val(dados.FNCDST);
                    $('#txtDatFncDstLog').val(dados.DATFNCDST);                                       

                    editar();
                    $('#divCadastro').show();
                    $('#divPesquisa').hide();
                });
            }
        });

    };

     @*Botão que ativa os itens*@
    $("#btnAtivar").click(function () {

        var arrayCodigo = chkGrider.markList;

        if (arrayCodigo.length != 0) {

            swal({
                title: 'Ativar?',
                text: "Deseja ativar os itens selecionado?",
                showCancelButton: true,
                cancelButtonColor: '#d33',
                cancelButtonText: 'Cancelar',
                confirmButtonColor: '#3085d6',
                confirmButtonText: 'Ativar!'
            }).then(function (result) {
                if (result.value) {
                var arrayList = [];
                for (i = 0; i < arrayCodigo.length; i++) {
                    if (arrayCodigo[i].CODFNCCHECK > 0) {
                        arrayList.push(arrayCodigo[i].CODFNCCHECK);
                    }
                }

                $.ajax({
                    method: 'POST',
                    url: '@Url.Content("~/api/CadastroConsultor/AtivarCadastroConsultor")',
                    headers: { '__RequestVerificationToken': $('input[name="__RequestVerificationToken"]').val() },
                    async: false,
                    data: { LISTCODFNC : arrayList} ,
                    success: function (response) {
                        if (response.Code > 0) {
                            swal("Verificar!", "Itens não foram ativados verificar!");
                            setCustomIcon('fa fa-window-close');
                        }
                        else{
                            swal("Ativado!", "Itens ativados com sucesso!");
                            setCustomIcon('fa fa-exclamation-circle');
                            $("#grdCadastroConsultor").DataTable().ajax.reload();
                            $('#dvAtvDsvContent').fadeOut();
                            arrayCodigo.length = 0;
                            arrayList.length = 0;
                        }
                     }
                 });
                }
                else {
                    $('#dvAtvDsvContent').fadeOut();
                }
            });
        }
        else {
            swal("Atenção", "Selecione pelo menos um item para continuar.");
            setCustomIcon('fa fa-window-close');
            $('#dvAtvDsvContent').fadeOut();
        }
        if (arrayCodigo.length != 0) {
            setCustomIcon('fa fa-question-circle');
        }
    });

    @*Botão que desativa os itens*@
    $("#btnDesativar").click(function () {

        var arrayCodigo = chkGrider.markList;

        if (arrayCodigo.length != 0) {

            swal({
                title: 'Desativar?',
                text: "Deseja Desativar os itens selecionado?",
                showCancelButton: true,
                cancelButtonColor: '#d33',
                cancelButtonText: 'Cancelar',
                confirmButtonColor: '#3085d6',
                confirmButtonText: 'Desativar!'
            }).then(function (result) {
                if (result.value) {
                    var arrayList = [];
                    for (i = 0; i < arrayCodigo.length; i++) {
                        if (arrayCodigo[i].CODFNCCHECK > 0) {
                            arrayList.push(arrayCodigo[i].CODFNCCHECK);
                        }
                    }

                    $.ajax({
                        method: 'POST',
                        url: '@Url.Content("~/api/CadastroConsultor/DesativarCadastroConsultor")',
                        headers: { '__RequestVerificationToken': $('input[name="__RequestVerificationToken"]').val() },
                        async: false,
                        data: { LISTCODFNC: arrayList },
                        success: function (result) {

                            if (result.split(',')[0] == "1") {
                                swal("Desativado!", "Itens desativados com sucesso!");
                                setCustomIcon('fa fa-exclamation-circle');
                                $("#grdCadastroConsultor").DataTable().ajax.reload();
                                $('#dvAtvDsvContent').fadeOut();
                                arrayCodigo.length = 0;
                                arrayList.length = 0;
                            }
                            else if (result.split(',')[0] == "2") {
                                swal("Verificar!", "O(s) Usuário(s)" + result.split(',')[1] + "possui titulo vinculado!");
                                setCustomIcon('fa fa-window-close');
                            }
                            else {
                                swal("Verificar!", "O(s) suário(s) não foram desativados!");
                                setCustomIcon('fa fa-window-close');
                            }

                        }
                    });
                }
                else {
                    $('#dvAtvDsvContent').fadeOut();
                }
            });
        }
        else {
            swal("Atenção", "Selecione pelo menos um item para continuar.");
            setCustomIcon('fa fa-window-close');
            $('#dvAtvDsvContent').fadeOut();
        }
        if (arrayCodigo.length != 0) {
            setCustomIcon('fa fa-question-circle');
        }
    });

     //Evento do Update do cadastro Editar
    $("#btnEditarCadastro").click(function () {

        if (tooltipValidationEditar() == false) {
            return;
        }

            with (new ComponenteAJAXFactory()) {
                with (modelo) {
                    ajaxSuccessCallbackMethod = function () {
                        swal('Alterado!', 'Alteração realizada com sucesso!');
                        setCustomIcon('fa fa-exclamation-circle');
                        limparTodosOsCampos("divCadastro");
                        $('#divCadastro').hide();
                        $('#divPesquisa').show();
                        $("#grdCadastroConsultor").DataTable().ajax.reload();
                        $('#selFnc').text(null).trigger('change');
                        apagaTooltipCampos();
                    };
                    ajaxURL = '@Url.Content("~/api/CadastroConsultor/AlterarCadastroConsultor")';
                    async = true;
                    with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CODFNC", idJsonEnviar = "txtCodFnc", tipoJsonEnviar = 'tipoNumerico' };
                    with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CODPFLACS", idJsonEnviar = "ddlCodPflAcs", tipoJsonEnviar = 'tipoNumerico' };
                    with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CONATI", idJsonEnviar = "rbDesativar", tipoJsonEnviar = 'tipoCheckBox' };
                };
                inicializar(null);
            };
    });

    //Evento do Insert do cadastro Inserir
    $("#btnInserirCadastro").click(function () {

        if (tooltipValidationNovo() == false) {
            return;
        }

            with (new ComponenteAJAXFactory()) {
                with (modelo) {
                    ajaxSuccessCallbackMethod = function (e) {
                        if (e != 1) {
                            swal('Inserido!', 'Inserção realizada com sucesso!');
                            setCustomIcon('fa fa-exclamation-circle');
                            limparTodosOsCampos("divCadastro");
                            $('#divCadastro').hide();
                            $('#divPesquisa').show();
                            $("#grdCadastroConsultor").DataTable().ajax.reload();
                            $('#selFnc').text(null).trigger('change');
                            apagaTooltipCampos();
                        }
                        else {
                            swal('Verificar!', "O Funcionário está cadastrado!");
                            setCustomIcon('fa fa-window-close');
                        }
                    };
                    ajaxURL = '@Url.Content("~/api/CadastroConsultor/InserirCadastroConsultor")';
                    async = true;
                    with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CODFNC", idJsonEnviar = "selFnc", tipoJsonEnviar = 'tipoNumerico' };
                    with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CODPFLACS", idJsonEnviar = "ddlCodPflAcs", tipoJsonEnviar = 'tipoNumerico' };
                };
                inicializar(null);
            };
    });

//Page Load.
    $(function () {

        var _codfunc =  @ControleDeAcesso.ObterConjuntoDePermissoesUsuario().InformacoesUsuario.CODFNC.ToString();
        if (_codfunc == 90900225) {

            swal({
                title: 'Verificar',
                text: "Acesso Não Permitido",
                showCancelButton: false,
                confirmButtonColor: '#3085d6',
                confirmButtonText: 'Sim!'
            }).then(function (result) {
                if (result.value) {
                    $(location).attr('href', '@Url.Content("~/Paginas/Default/Index")');
                }
            });

            return;
        }



        mostrarCaminhoMenu('Parâmetros', 'Consultor');

         //Carrega informações iniciais ao informar a matricula do funcionário.
        $('#selFnc').change(function () {
            tooltipApagarValidation("#txtFnc");

            $('#txtFnc').val('');

             if ($('#selFnc').val() != null) {

                with (new ComponenteValueBinder()) {
	            with (modelo) {
	                ajaxPostURL = '@Url.Content("~/api/CadastroPessoaIndicacao/ObterFuncionarios")';
                    with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CODFNC", idJsonEnviar = "selFnc", tipoJsonEnviar = 'tipoNumerico' };

                    with (addidsSetarRequisicaoAjax) { idJsonSetar = "txtFnc", nomeJsonSetar = "CODFNC", textoJsonSetar = "CODFNC", tipoJsonSetar = 'tipoTexto' };

	            };
	            inicializar();
	            };
             }
        })

        //Carregamente inicial do data table.
        // A consulta do pesquisar é feita nesse local ao acionar o .DataTable().ajax.reload, nesse caso ele manda as informações pelo Json
        with (new ComponenteDataTables()) {
            with (modelo) {
                carregarInicialmente = true;
                idContainerControle = "grdCadastroConsultorContainer"
                idControle = "grdCadastroConsultor";
                ajaxPostURL = '@Url.Content("~/api/CadastroConsultor/ObterCadastroConsultor")';
                naoFiltrarPorColuna = true;
                naoFixarColunas = true;
                fnDrawCallback = csnCallBack;
                //
                with (addBotoes) {
                nomeBotao = "btnNovo";
                nomeClasse = "btn black";
                texto = "<i class='fa fa-plus'></i> Novo";
                };
                //
                @*Botão da grid do lado direto*@
                with (addBotoes) {
                    nomeBotao = "btnAtivarDesativarGrid";
                    nomeClasse = "dropdown-toggle";
                    texto = '<i class="fa fa-power-off" aria-hidden="true"></i> Ativar/Desativar';
                };
                //
                with (addColunas) { cabecalho = "{check}", nomeColuna = "CODFNCCHECK", classeColuna = "check-this" };
                with (addColunas) { cabecalho = "Cód.", nomeColuna = "CODFNC", classeColuna = "text-right" };
                with (addColunas) { cabecalho = "Descrição", nomeColuna = "NOMFNC" };
                with (addColunas) { cabecalho = "Perfil", nomeColuna = "NOMCODPFLACS", classeColuna = "text-center" };
                with (addColunas) { cabecalho = "Status", nomeColuna = "STATUS", classeColuna = "text-center"};
                //
                //Essas são as informações que só são enviadas quando o botão pesquisar é acionado
                with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CODFNCFIL", idJsonEnviar = "selCon", tipoJsonEnviar = 'tipoNumerico' };
                with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CONATIFIL", idJsonEnviar = "ddlStatus", tipoJsonEnviar = 'tipoNumerico' };                
                with (addidsEnviarRequisicaoAjax) { nomeJsonEnviar = "CODPFLACS", idJsonEnviar = "ddlPerfil", tipoJsonEnviar = 'tipoNumerico' };

                }
                inicializar(null);
        }

        //Clique para mostrar a modal de cadastro, e para apagar as informações dos campos para a chamada da modal.
        $(".btnNovo").click(function () {
            $('#divPesquisa').hide();
            $('#divCadastro').show();

            $('#ddlCodPflAcs').val(0);

            novo();
        });

        @*Função para que o drop do ativar / desativar feche ao clicar fora*@
        $('body').append($('#dvAtvDsvContent').detach());
        @*Função para mostrar o drop da grid*@
        $('.btnAtivarDesativarGrid').click(function () {
            var btn = $(this);
            var offset = btn.offset();
            $('#dvAtvDsvContent').css({
                'left': offset.left,
                'top': offset.top + 40
            }).show().width(btn.width() + 50);
            //-
            $('body').append($('<div class="drop-background">').click(function () {
                $('#dvAtvDsvContent').fadeOut();
                $(this).remove();
            }));
        });
    });

</script>